/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-01 at 19:46:09 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON response template to list aliases in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Directory API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Aliases extends com.google.api.client.json.GenericJson {

  /**
   * List of alias objects.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Alias> aliases;

  static {
    // hack to force ProGuard to consider Alias used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Alias.class);
  }

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * List of alias objects.
   * @return value or {@code null} for none
   */
  public java.util.List<Alias> getAliases() {
    return aliases;
  }

  /**
   * List of alias objects.
   * @param aliases aliases or {@code null} for none
   */
  public Aliases setAliases(java.util.List<Alias> aliases) {
    this.aliases = aliases;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public Aliases setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public Aliases set(String fieldName, Object value) {
    return (Aliases) super.set(fieldName, value);
  }

  @Override
  public Aliases clone() {
    return (Aliases) super.clone();
  }

}
