/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-01 at 19:46:09 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON template for User object in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Directory API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class User extends com.google.api.client.json.GenericJson {

  /**
   * Addresses of User
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserAddress> addresses;

  static {
    // hack to force ProGuard to consider UserAddress used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(UserAddress.class);
  }

  /**
   * Indicates if user has agreed to terms (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean agreedToTerms;

  /**
   * List of aliases (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> aliases;

  /**
   * Boolean indicating if the user should change password in next login
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean changePasswordAtNextLogin;

  /**
   * User's Google account creation time. (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime creationTime;

  /**
   * CustomerId of User (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customerId;

  /**
   * Emails of User
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserEmail> emails;

  /**
   * The external Ids of User *
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserExternalId> externalIds;

  /**
   * Hash function name for password. Supported are MD5, SHA-1 and crypt
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String hashFunction;

  /**
   * Unique identifier of User (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * User's Instant Messenger
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserIm> ims;

  static {
    // hack to force ProGuard to consider UserIm used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(UserIm.class);
  }

  /**
   * Boolean indicating if user is included in Global Address List
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean includeInGlobalAddressList;

  /**
   * Boolean indicating if ip is whitelisted
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean ipWhitelisted;

  /**
   * Boolean indicating if the user is admin (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isAdmin;

  /**
   * Boolean indicating if the user is delegated admin (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isDelegatedAdmin;

  /**
   * Is mailbox setup (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isMailboxSetup;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * User's last login time. (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime lastLoginTime;

  /**
   * User's name
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private UserName name;

  /**
   * List of non editable aliases (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> nonEditableAliases;

  /**
   * OrgUnit of User
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String orgUnitPath;

  /**
   * Organizations of User
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserOrganization> organizations;

  static {
    // hack to force ProGuard to consider UserOrganization used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(UserOrganization.class);
  }

  /**
   * User's password
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String password;

  /**
   * Phone numbers of User
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserPhone> phones;

  /**
   * username of User
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String primaryEmail;

  /**
   * The Relations of User *
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<UserRelation> relations;

  /**
   * Indicates if user is suspended
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean suspended;

  /**
   * Suspension reason if user is suspended (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String suspensionReason;

  /**
   * Photo Url of the user (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String thumbnailPhotoUrl;

  /**
   * Addresses of User
   * @return value or {@code null} for none
   */
  public java.util.List<UserAddress> getAddresses() {
    return addresses;
  }

  /**
   * Addresses of User
   * @param addresses addresses or {@code null} for none
   */
  public User setAddresses(java.util.List<UserAddress> addresses) {
    this.addresses = addresses;
    return this;
  }

  /**
   * Indicates if user has agreed to terms (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getAgreedToTerms() {
    return agreedToTerms;
  }

  /**
   * Indicates if user has agreed to terms (Read-only)
   * @param agreedToTerms agreedToTerms or {@code null} for none
   */
  public User setAgreedToTerms(java.lang.Boolean agreedToTerms) {
    this.agreedToTerms = agreedToTerms;
    return this;
  }

  /**
   * List of aliases (Read-only)
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getAliases() {
    return aliases;
  }

  /**
   * List of aliases (Read-only)
   * @param aliases aliases or {@code null} for none
   */
  public User setAliases(java.util.List<java.lang.String> aliases) {
    this.aliases = aliases;
    return this;
  }

  /**
   * Boolean indicating if the user should change password in next login
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getChangePasswordAtNextLogin() {
    return changePasswordAtNextLogin;
  }

  /**
   * Boolean indicating if the user should change password in next login
   * @param changePasswordAtNextLogin changePasswordAtNextLogin or {@code null} for none
   */
  public User setChangePasswordAtNextLogin(java.lang.Boolean changePasswordAtNextLogin) {
    this.changePasswordAtNextLogin = changePasswordAtNextLogin;
    return this;
  }

  /**
   * User's Google account creation time. (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreationTime() {
    return creationTime;
  }

  /**
   * User's Google account creation time. (Read-only)
   * @param creationTime creationTime or {@code null} for none
   */
  public User setCreationTime(com.google.api.client.util.DateTime creationTime) {
    this.creationTime = creationTime;
    return this;
  }

  /**
   * CustomerId of User (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomerId() {
    return customerId;
  }

  /**
   * CustomerId of User (Read-only)
   * @param customerId customerId or {@code null} for none
   */
  public User setCustomerId(java.lang.String customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * Emails of User
   * @return value or {@code null} for none
   */
  public java.util.List<UserEmail> getEmails() {
    return emails;
  }

  /**
   * Emails of User
   * @param emails emails or {@code null} for none
   */
  public User setEmails(java.util.List<UserEmail> emails) {
    this.emails = emails;
    return this;
  }

  /**
   * The external Ids of User *
   * @return value or {@code null} for none
   */
  public java.util.List<UserExternalId> getExternalIds() {
    return externalIds;
  }

  /**
   * The external Ids of User *
   * @param externalIds externalIds or {@code null} for none
   */
  public User setExternalIds(java.util.List<UserExternalId> externalIds) {
    this.externalIds = externalIds;
    return this;
  }

  /**
   * Hash function name for password. Supported are MD5, SHA-1 and crypt
   * @return value or {@code null} for none
   */
  public java.lang.String getHashFunction() {
    return hashFunction;
  }

  /**
   * Hash function name for password. Supported are MD5, SHA-1 and crypt
   * @param hashFunction hashFunction or {@code null} for none
   */
  public User setHashFunction(java.lang.String hashFunction) {
    this.hashFunction = hashFunction;
    return this;
  }

  /**
   * Unique identifier of User (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Unique identifier of User (Read-only)
   * @param id id or {@code null} for none
   */
  public User setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * User's Instant Messenger
   * @return value or {@code null} for none
   */
  public java.util.List<UserIm> getIms() {
    return ims;
  }

  /**
   * User's Instant Messenger
   * @param ims ims or {@code null} for none
   */
  public User setIms(java.util.List<UserIm> ims) {
    this.ims = ims;
    return this;
  }

  /**
   * Boolean indicating if user is included in Global Address List
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIncludeInGlobalAddressList() {
    return includeInGlobalAddressList;
  }

  /**
   * Boolean indicating if user is included in Global Address List
   * @param includeInGlobalAddressList includeInGlobalAddressList or {@code null} for none
   */
  public User setIncludeInGlobalAddressList(java.lang.Boolean includeInGlobalAddressList) {
    this.includeInGlobalAddressList = includeInGlobalAddressList;
    return this;
  }

  /**
   * Boolean indicating if ip is whitelisted
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIpWhitelisted() {
    return ipWhitelisted;
  }

  /**
   * Boolean indicating if ip is whitelisted
   * @param ipWhitelisted ipWhitelisted or {@code null} for none
   */
  public User setIpWhitelisted(java.lang.Boolean ipWhitelisted) {
    this.ipWhitelisted = ipWhitelisted;
    return this;
  }

  /**
   * Boolean indicating if the user is admin (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsAdmin() {
    return isAdmin;
  }

  /**
   * Boolean indicating if the user is admin (Read-only)
   * @param isAdmin isAdmin or {@code null} for none
   */
  public User setIsAdmin(java.lang.Boolean isAdmin) {
    this.isAdmin = isAdmin;
    return this;
  }

  /**
   * Boolean indicating if the user is delegated admin (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsDelegatedAdmin() {
    return isDelegatedAdmin;
  }

  /**
   * Boolean indicating if the user is delegated admin (Read-only)
   * @param isDelegatedAdmin isDelegatedAdmin or {@code null} for none
   */
  public User setIsDelegatedAdmin(java.lang.Boolean isDelegatedAdmin) {
    this.isDelegatedAdmin = isDelegatedAdmin;
    return this;
  }

  /**
   * Is mailbox setup (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsMailboxSetup() {
    return isMailboxSetup;
  }

  /**
   * Is mailbox setup (Read-only)
   * @param isMailboxSetup isMailboxSetup or {@code null} for none
   */
  public User setIsMailboxSetup(java.lang.Boolean isMailboxSetup) {
    this.isMailboxSetup = isMailboxSetup;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public User setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * User's last login time. (Read-only)
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getLastLoginTime() {
    return lastLoginTime;
  }

  /**
   * User's last login time. (Read-only)
   * @param lastLoginTime lastLoginTime or {@code null} for none
   */
  public User setLastLoginTime(com.google.api.client.util.DateTime lastLoginTime) {
    this.lastLoginTime = lastLoginTime;
    return this;
  }

  /**
   * User's name
   * @return value or {@code null} for none
   */
  public UserName getName() {
    return name;
  }

  /**
   * User's name
   * @param name name or {@code null} for none
   */
  public User setName(UserName name) {
    this.name = name;
    return this;
  }

  /**
   * List of non editable aliases (Read-only)
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getNonEditableAliases() {
    return nonEditableAliases;
  }

  /**
   * List of non editable aliases (Read-only)
   * @param nonEditableAliases nonEditableAliases or {@code null} for none
   */
  public User setNonEditableAliases(java.util.List<java.lang.String> nonEditableAliases) {
    this.nonEditableAliases = nonEditableAliases;
    return this;
  }

  /**
   * OrgUnit of User
   * @return value or {@code null} for none
   */
  public java.lang.String getOrgUnitPath() {
    return orgUnitPath;
  }

  /**
   * OrgUnit of User
   * @param orgUnitPath orgUnitPath or {@code null} for none
   */
  public User setOrgUnitPath(java.lang.String orgUnitPath) {
    this.orgUnitPath = orgUnitPath;
    return this;
  }

  /**
   * Organizations of User
   * @return value or {@code null} for none
   */
  public java.util.List<UserOrganization> getOrganizations() {
    return organizations;
  }

  /**
   * Organizations of User
   * @param organizations organizations or {@code null} for none
   */
  public User setOrganizations(java.util.List<UserOrganization> organizations) {
    this.organizations = organizations;
    return this;
  }

  /**
   * User's password
   * @return value or {@code null} for none
   */
  public java.lang.String getPassword() {
    return password;
  }

  /**
   * User's password
   * @param password password or {@code null} for none
   */
  public User setPassword(java.lang.String password) {
    this.password = password;
    return this;
  }

  /**
   * Phone numbers of User
   * @return value or {@code null} for none
   */
  public java.util.List<UserPhone> getPhones() {
    return phones;
  }

  /**
   * Phone numbers of User
   * @param phones phones or {@code null} for none
   */
  public User setPhones(java.util.List<UserPhone> phones) {
    this.phones = phones;
    return this;
  }

  /**
   * username of User
   * @return value or {@code null} for none
   */
  public java.lang.String getPrimaryEmail() {
    return primaryEmail;
  }

  /**
   * username of User
   * @param primaryEmail primaryEmail or {@code null} for none
   */
  public User setPrimaryEmail(java.lang.String primaryEmail) {
    this.primaryEmail = primaryEmail;
    return this;
  }

  /**
   * The Relations of User *
   * @return value or {@code null} for none
   */
  public java.util.List<UserRelation> getRelations() {
    return relations;
  }

  /**
   * The Relations of User *
   * @param relations relations or {@code null} for none
   */
  public User setRelations(java.util.List<UserRelation> relations) {
    this.relations = relations;
    return this;
  }

  /**
   * Indicates if user is suspended
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getSuspended() {
    return suspended;
  }

  /**
   * Indicates if user is suspended
   * @param suspended suspended or {@code null} for none
   */
  public User setSuspended(java.lang.Boolean suspended) {
    this.suspended = suspended;
    return this;
  }

  /**
   * Suspension reason if user is suspended (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getSuspensionReason() {
    return suspensionReason;
  }

  /**
   * Suspension reason if user is suspended (Read-only)
   * @param suspensionReason suspensionReason or {@code null} for none
   */
  public User setSuspensionReason(java.lang.String suspensionReason) {
    this.suspensionReason = suspensionReason;
    return this;
  }

  /**
   * Photo Url of the user (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getThumbnailPhotoUrl() {
    return thumbnailPhotoUrl;
  }

  /**
   * Photo Url of the user (Read-only)
   * @param thumbnailPhotoUrl thumbnailPhotoUrl or {@code null} for none
   */
  public User setThumbnailPhotoUrl(java.lang.String thumbnailPhotoUrl) {
    this.thumbnailPhotoUrl = thumbnailPhotoUrl;
    return this;
  }

  @Override
  public User set(String fieldName, Object value) {
    return (User) super.set(fieldName, value);
  }

  @Override
  public User clone() {
    return (User) super.clone();
  }

}
